/**
 * A thing that creates {@linkcode typedoc#DeclarationReflection} instances from parsed
 * command & execute method data.
 * @module
 */
import { Context } from 'typedoc';
import { AppiumPluginLogger } from '../logger';
import { ModuleCommands } from '../model';
/**
 * Creates custom {@linkcode typedoc#DeclarationReflection}s from parsed command & execute method data.
 *
 * These instances are added to the {@linkcode Context} object itself; this mutates TypeDoc's internal state. Nothing is returned.
 * @param ctx TypeDoc Context
 * @param parentLog Plugin logger
 * @param commandInfo Command info from converter; a map of parent reflections to parsed data
 */
export declare function createReflections(ctx: Context, parentLog: AppiumPluginLogger, commandInfo: ModuleCommands): void;
//# sourceMappingURL=builder.d.ts.map