"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.CommandInfo = void 0;
/**
 * Data structure describing routes and commands for a particular module (or project),
 * including execute methods (if any)
 */
class CommandInfo {
    constructor(routeMap, execMethodDataSet = new Set()) {
        this.routeMap = routeMap;
        this.execMethodDataSet = execMethodDataSet;
    }
    /**
     * Returns `true` if this instance has some actual data
     */
    get hasData() {
        return Boolean(this.execMethodDataSet.size + this.routeMap.size);
    }
}
exports.CommandInfo = CommandInfo;
//# sourceMappingURL=command-info.js.map