"use strict";
var __classPrivateFieldSet = (this && this.__classPrivateFieldSet) || function (receiver, state, value, kind, f) {
    if (kind === "m") throw new TypeError("Private method is not writable");
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a setter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot write private member to an object whose class did not declare it");
    return (kind === "a" ? f.call(receiver, value) : f ? f.value = value : state.set(receiver, value)), value;
};
var __classPrivateFieldGet = (this && this.__classPrivateFieldGet) || function (receiver, state, kind, f) {
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a getter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot read private member from an object whose class did not declare it");
    return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
};
var _AppiumTheme_instances, _AppiumTheme_commandsTemplateRenderer, _AppiumTheme_log, _AppiumTheme_createTemplateRenderer;
Object.defineProperty(exports, "__esModule", { value: true });
exports.AppiumTheme = exports.THEME_NAME = void 0;
const typedoc_plugin_markdown_1 = require("typedoc-plugin-markdown");
const logger_1 = require("../logger");
const model_1 = require("../model");
const helpers_1 = require("./helpers");
const template_1 = require("./template");
/**
 * Name of the theme; used at definition time
 */
exports.THEME_NAME = 'appium';
class AppiumTheme extends typedoc_plugin_markdown_1.MarkdownTheme {
    /**
     * Creates template renderers and registers all {@linkcode Handlebars} helpers.
     * @param renderer - TypeDoc renderer
     *
     * @todo Make `hideBreadcrumbs` configurable
     */
    constructor(renderer) {
        super(renderer);
        _AppiumTheme_instances.add(this);
        /**
         * A template renderer for `CommandReflection`s
         */
        _AppiumTheme_commandsTemplateRenderer.set(this, void 0);
        /**
         * Custom logger.  This is not the same as the one created by the plugin loader.
         */
        _AppiumTheme_log.set(this, void 0);
        // ideally, this would be a child of the logger created by the `load()` function,
        // but I don't know how to get at it.
        __classPrivateFieldSet(this, _AppiumTheme_log, new logger_1.AppiumPluginLogger(renderer.owner.logger, `${model_1.NS}:theme`), "f");
        __classPrivateFieldSet(this, _AppiumTheme_commandsTemplateRenderer, __classPrivateFieldGet(this, _AppiumTheme_instances, "m", _AppiumTheme_createTemplateRenderer).call(this, template_1.AppiumThemeTemplate.Commands), "f");
        // the intent is to have mkdocs render breadcrumbs
        this.hideBreadcrumbs = true;
        // this ensures we can overwrite MarkdownTheme's Handlebars helpers
        (0, helpers_1.registerHelpers)();
    }
    /**
     * This is essentially a lookup of {@linkcode ReflectionKind}s to templates.  It also controls in which directory the output files live.
     *
     * If `isLeaf` is `false`, the model gets its own document.
     */
    get mappings() {
        return [
            {
                kind: [model_1.AppiumPluginReflectionKind.COMMANDS],
                isLeaf: false,
                directory: 'commands',
                template: __classPrivateFieldGet(this, _AppiumTheme_commandsTemplateRenderer, "f"),
            },
            ...super.mappings,
        ];
    }
}
exports.AppiumTheme = AppiumTheme;
_AppiumTheme_commandsTemplateRenderer = new WeakMap(), _AppiumTheme_log = new WeakMap(), _AppiumTheme_instances = new WeakSet(), _AppiumTheme_createTemplateRenderer = function _AppiumTheme_createTemplateRenderer(template) {
    const render = (0, template_1.compileTemplate)(template);
    return (pageEvent) => {
        __classPrivateFieldGet(this, _AppiumTheme_log, "f").verbose('Rendering template for model %s', pageEvent.model.name);
        return render(pageEvent, {
            allowProtoMethodsByDefault: true,
            allowProtoPropertiesByDefault: true,
            data: { theme: this },
        });
    };
};
//# sourceMappingURL=index.js.map